# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from typing import Union, Optional
from datetime import datetime
from typing_extensions import Literal, TypeAlias

from ..._models import BaseModel
from .schema_generation_base import SchemaGenerationBase
from .artifact_schema_generation import ArtifactSchemaGeneration

__all__ = ["TestCase", "TestCaseData"]

TestCaseData: TypeAlias = Union[ArtifactSchemaGeneration, SchemaGenerationBase]


class TestCase(BaseModel):
    __test__ = False
    id: str
    """The unique identifier of the entity."""

    account_id: str
    """The ID of the account that owns the given entity."""

    autogenerated: bool
    """Boolean to track whether or not the test case is autogenerated"""

    created_at: datetime
    """The date and time when the entity was created in ISO format."""

    created_by_user_id: str
    """The user who originally created the entity."""

    evaluation_dataset_id: str
    """The ID of the associated evaluation dataset."""

    schema_type: Literal["GENERATION"]
    """An enumeration."""

    test_case_data: TestCaseData
    """The data for the test case in a format matching the provided schema_type"""

    archived_at: Optional[datetime] = None
    """The date and time when the entity was archived in ISO format."""

    chat_history: Optional[object] = None
    """Used for tracking previous chat interactions for multi-chat test cases"""

    test_case_metadata: Optional[object] = None
    """Metadata for the test case"""
